import 'dart:convert';

// ignore: camel_case_types
class Album_More_info {
  final String music;
  final int ctr;
  final String year;
  final String is_movie;
  final String language;
  final String song_pids;
  final String firstname;
  final List<String> artist_name;
  final String entity_type;
  final String entity_sub_type;
  final bool video_available;
  final bool is_dolby_content;

  final String lastname;
  Album_More_info({
    required this.music,
    required this.ctr,
    required this.year,
    required this.is_movie,
    required this.language,
    required this.song_pids,
    required this.firstname,
    required this.artist_name,
    required this.entity_type,
    required this.entity_sub_type,
    required this.video_available,
    required this.is_dolby_content,
    required this.lastname,
  });

  Album_More_info copyWith({
    String? music,
    int? ctr,
    String? year,
    String? is_movie,
    String? language,
    String? song_pids,
    String? firstname,
    List<String>? artist_name,
    String? entity_type,
    String? entity_sub_type,
    bool? video_available,
    bool? is_dolby_content,
    String? lastname,
  }) {
    return Album_More_info(
      music: music ?? this.music,
      ctr: ctr ?? this.ctr,
      year: year ?? this.year,
      is_movie: is_movie ?? this.is_movie,
      language: language ?? this.language,
      song_pids: song_pids ?? this.song_pids,
      firstname: firstname ?? this.firstname,
      artist_name: artist_name ?? this.artist_name,
      entity_type: entity_type ?? this.entity_type,
      entity_sub_type: entity_sub_type ?? this.entity_sub_type,
      video_available: video_available ?? this.video_available,
      is_dolby_content: is_dolby_content ?? this.is_dolby_content,
      lastname: lastname ?? this.lastname,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'music': music,
      'ctr': ctr,
      'year': year,
      'is_movie': is_movie,
      'language': language,
      'song_pids': song_pids,
    };
  }

  factory Album_More_info.fromMap(Map<String, dynamic> map) {
    if (map.isNotEmpty) {
      return Album_More_info(
        music: map['music'],
        ctr: map['ctr']?.toInt(),
        year: map['year'],
        is_movie: map['is_movie'],
        language: map['language'],
        song_pids: map['song_pids'],
        firstname: map['firstname'],
        artist_name: map['artist_name'] != null
            ? List<String>.from(map['artist_name'])
            : [],
        entity_type: map['entity_type'],
        entity_sub_type: map['entity_sub_type'],
        video_available: map['video_available'],
        is_dolby_content: map['is_dolby_content'],
        lastname: map['lastname'],
      );
    } else {
      return Album_More_info(
        music: '',
        ctr: 0,
        year: '',
        is_movie: '',
        language: '',
        song_pids: '',
        firstname: '',
        artist_name: [''],
        entity_type: '',
        entity_sub_type: '',
        video_available: false,
        is_dolby_content: false,
        lastname: '',
      );
    }
  }

  String toJson() => json.encode(toMap());

  factory Album_More_info.fromJson(String source) =>
      Album_More_info.fromMap(json.decode(source));

  @override
  String toString() {
    return 'More_info(music: $music, ctr: $ctr, year: $year, is_movie: $is_movie, language: $language, song_pids: $song_pids)';
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Album_More_info &&
        other.music == music &&
        other.ctr == ctr &&
        other.year == year &&
        other.is_movie == is_movie &&
        other.language == language &&
        other.song_pids == song_pids;
  }

  @override
  int get hashCode {
    return music.hashCode ^
        ctr.hashCode ^
        year.hashCode ^
        is_movie.hashCode ^
        language.hashCode ^
        song_pids.hashCode;
  }
}
