import 'package:flutter/foundation.dart';

import 'primary_artists.dart';

class ArtistMap {
  List<PrimaryArtists>? primaryArtists;
  List<PrimaryArtists>? featuredArtists;
  List<PrimaryArtists>? artists;
  ArtistMap({
    this.primaryArtists,
    this.featuredArtists,
    this.artists,
  });

  ArtistMap.fromJson(Map<String?, dynamic> json) {
    if (json['primary_artists'] != null) {
      primaryArtists = [];
      json['primary_artists'].forEach((v) {
        primaryArtists!.add(new PrimaryArtists.fromJson(v));
      });
    }
    if (json['featured_artists'] != null) {
      featuredArtists = [];
      json['featured_artists'].forEach((v) {
        featuredArtists!.add(new PrimaryArtists.fromJson(v));
      });
    }
    if (json['artists'] != null) {
      artists = [];
      json['artists'].forEach((v) {
        artists!.add(new PrimaryArtists.fromJson(v));
      });
    }
  }

  Map<String?, dynamic> toJson() {
    final Map<String?, dynamic> data = new Map<String?, dynamic>();
    if (this.primaryArtists != null) {
      data['primary_artists'] =
          this.primaryArtists!.map((v) => v.toJson()).toList();
    }
    if (this.featuredArtists != null) {
      data['featured_artists'] =
          this.featuredArtists!.map((v) => v.toJson()).toList();
    }
    if (this.artists != null) {
      data['artists'] = this.artists!.map((v) => v.toJson()).toList();
    }
    return data;
  }

  ArtistMap copyWith({
    List<PrimaryArtists>? primaryArtists,
    List<PrimaryArtists>? featuredArtists,
    List<PrimaryArtists>? artists,
  }) {
    return ArtistMap(
      primaryArtists: primaryArtists ?? this.primaryArtists,
      featuredArtists: featuredArtists ?? this.featuredArtists,
      artists: artists ?? this.artists,
    );
  }

  @override
  String toString() =>
      'ArtistMap(primaryArtists: $primaryArtists, featuredArtists: $featuredArtists, artists: $artists)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is ArtistMap &&
        listEquals(other.primaryArtists, primaryArtists) &&
        listEquals(other.featuredArtists, featuredArtists) &&
        listEquals(other.artists, artists);
  }

  @override
  int get hashCode =>
      primaryArtists.hashCode ^ featuredArtists.hashCode ^ artists.hashCode;
}
