import 'dart:convert';

import 'package:flutter/foundation.dart';

class Artists {
  final List<dynamic> data;
  final int position;
  Artists({
    required this.data,
    required this.position,
  });

  Artists copyWith({
    List<dynamic>? data,
    int? position,
  }) {
    return Artists(
      data: data ?? this.data,
      position: position ?? this.position,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'data': data,
      'position': position,
    };
  }

  factory Artists.fromMap(Map<String, dynamic> map) {
    return Artists(
      data: List<dynamic>.from(map['data']),
      position: map['position']?.toInt(),
    );
  }

  String toJson() => json.encode(toMap());

  factory Artists.fromJson(String source) =>
      Artists.fromMap(json.decode(source));

  @override
  String toString() => 'Artists(data: $data, position: $position)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Artists &&
        listEquals(other.data, data) &&
        other.position == position;
  }

  @override
  int get hashCode => data.hashCode ^ position.hashCode;
}
