import 'dart:convert';

import 'package:flutter/foundation.dart';

class Episodes {
  final List<dynamic> data;
  final int position;
  Episodes({
    required this.data,
    required this.position,
  });

  Episodes copyWith({
    List<dynamic>? data,
    int? position,
  }) {
    return Episodes(
      data: data ?? this.data,
      position: position ?? this.position,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'data': data,
      'position': position,
    };
  }

  factory Episodes.fromMap(Map<String, dynamic> map) {
    return Episodes(
      data: List<dynamic>.from(map['data']),
      position: map['position']?.toInt(),
    );
  }

  String toJson() => json.encode(toMap());

  factory Episodes.fromJson(String source) =>
      Episodes.fromMap(json.decode(source));

  @override
  String toString() => 'Episodes(data: $data, position: $position)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Episodes &&
        listEquals(other.data, data) &&
        other.position == position;
  }

  @override
  int get hashCode => data.hashCode ^ position.hashCode;
}
