import 'dart:convert';

import 'package:flutter/foundation.dart';

class Modules {
  List<Modulelist>? list;
  Modules({
    this.list,
  });

  Modules.fromJson(Map<String?, dynamic> json) {
    if (json['list'] != null) {
      list = [];
      json['list'].forEach((v) {
        list!.add(
            new Modulelist.fromJson(Map<String, dynamic>.from(jsonDecode(v))));
      });
    }
  }

  Map<String?, dynamic> toJson() {
    final Map<String?, dynamic> data = new Map<String?, dynamic>();
    if (this.list != null) {
      data['list'] = this.list!.map((v) => v.toJson()).toList();
    }
    return data;
  }

  Modules copyWith({
    List<Modulelist>? list,
  }) {
    return Modules(
      list: list ?? this.list,
    );
  }

  @override
  String toString() => 'Modules(list: $list)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Modules && listEquals(other.list, list);
  }

  @override
  int get hashCode => list.hashCode;
}

class Modulelist {
  String? source;
  int? position;
  String? scrollType;
  String? title;
  String? subtitle;
  String? highlight;
  bool? simpleHeader;
  bool? noHeader;
  List<String>? viewMore;
  Modulelist({
    this.source,
    this.position,
    this.scrollType,
    this.title,
    this.subtitle,
    this.highlight,
    this.simpleHeader,
    this.noHeader,
    this.viewMore,
  });

  Modulelist.fromJson(Map<String, dynamic> json) {
    source = json['source'];
    position = json['position'];
    scrollType = json['scroll_type'];
    title = json['title'];
    subtitle = json['subtitle'];
    highlight = json['highlight'];
    simpleHeader = json['simpleHeader'];
    noHeader = json['noHeader'];
    viewMore = json['view_more'].cast<String>();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['source'] = this.source;
    data['position'] = this.position;
    data['scroll_type'] = this.scrollType;
    data['title'] = this.title;
    data['subtitle'] = this.subtitle;
    data['highlight'] = this.highlight;
    data['simpleHeader'] = this.simpleHeader;
    data['noHeader'] = this.noHeader;
    data['view_more'] = this.viewMore;
    return data;
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Modulelist &&
        other.source == source &&
        other.position == position &&
        other.scrollType == scrollType &&
        other.title == title &&
        other.subtitle == subtitle &&
        other.highlight == highlight &&
        other.simpleHeader == simpleHeader &&
        other.noHeader == noHeader &&
        listEquals(other.viewMore, viewMore);
  }

  @override
  int get hashCode {
    return source.hashCode ^
        position.hashCode ^
        scrollType.hashCode ^
        title.hashCode ^
        subtitle.hashCode ^
        highlight.hashCode ^
        simpleHeader.hashCode ^
        noHeader.hashCode ^
        viewMore.hashCode;
  }

  Modulelist copyWith({
    String? source,
    int? position,
    String? scrollType,
    String? title,
    String? subtitle,
    String? highlight,
    bool? simpleHeader,
    bool? noHeader,
    List<String>? viewMore,
  }) {
    return Modulelist(
      source: source ?? this.source,
      position: position ?? this.position,
      scrollType: scrollType ?? this.scrollType,
      title: title ?? this.title,
      subtitle: subtitle ?? this.subtitle,
      highlight: highlight ?? this.highlight,
      simpleHeader: simpleHeader ?? this.simpleHeader,
      noHeader: noHeader ?? this.noHeader,
      viewMore: viewMore ?? this.viewMore,
    );
  }

  @override
  String toString() {
    return 'Modulelist(source: $source, position: $position, scrollType: $scrollType, title: $title, subtitle: $subtitle, highlight: $highlight, simpleHeader: $simpleHeader, noHeader: $noHeader, viewMore: $viewMore)';
  }
}
