class PrimaryArtists {
  String? id;
  String? name;
  String? role;
  String? image;
  String? type;
  String? permaUrl;
  PrimaryArtists({
    this.id,
    this.name,
    this.role,
    this.image,
    this.type,
    this.permaUrl,
  });

  PrimaryArtists.fromJson(Map<String?, dynamic> json) {
    id = json['id'];
    name = json['name'];
    role = json['role'];
    image = json['image'];
    type = json['type'];
    permaUrl = json['perma_url'];
  }

  Map<String?, dynamic> toJson() {
    final Map<String?, dynamic> data = new Map<String?, dynamic>();
    data['id'] = this.id;
    data['name'] = this.name;
    data['role'] = this.role;
    data['image'] = this.image;
    data['type'] = this.type;
    data['perma_url'] = this.permaUrl;
    return data;
  }

  PrimaryArtists copyWith({
    String? id,
    String? name,
    String? role,
    String? image,
    String? type,
    String? permaUrl,
  }) {
    return PrimaryArtists(
      id: id ?? this.id,
      name: name ?? this.name,
      role: role ?? this.role,
      image: image ?? this.image,
      type: type ?? this.type,
      permaUrl: permaUrl ?? this.permaUrl,
    );
  }

  @override
  String toString() {
    return 'PrimaryArtists(id: $id, name: $name, role: $role, image: $image, type: $type, permaUrl: $permaUrl)';
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is PrimaryArtists &&
        other.id == id &&
        other.name == name &&
        other.role == role &&
        other.image == image &&
        other.type == type &&
        other.permaUrl == permaUrl;
  }

  @override
  int get hashCode {
    return id.hashCode ^
        name.hashCode ^
        role.hashCode ^
        image.hashCode ^
        type.hashCode ^
        permaUrl.hashCode;
  }
}
