class Rights {
  String? code;
  String? cacheable;
  String? deleteCachedObject;
  String? reason;
  Rights({
    this.code,
    this.cacheable,
    this.deleteCachedObject,
    this.reason,
  });

  Rights.fromJson(Map<String?, dynamic> json) {
    code = json['code'];
    cacheable = json['cacheable'];
    deleteCachedObject = json['delete_cached_object'];
    reason = json['reason'];
  }

  Map<String?, dynamic> toJson() {
    final Map<String?, dynamic> data = new Map<String?, dynamic>();
    data['code'] = this.code;
    data['cacheable'] = this.cacheable;
    data['delete_cached_object'] = this.deleteCachedObject;
    data['reason'] = this.reason;
    return data;
  }

  Rights copyWith({
    String? code,
    String? cacheable,
    String? deleteCachedObject,
    String? reason,
  }) {
    return Rights(
      code: code ?? this.code,
      cacheable: cacheable ?? this.cacheable,
      deleteCachedObject: deleteCachedObject ?? this.deleteCachedObject,
      reason: reason ?? this.reason,
    );
  }

  @override
  String toString() {
    return 'Rights(code: $code, cacheable: $cacheable, deleteCachedObject: $deleteCachedObject, reason: $reason)';
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Rights &&
        other.code == code &&
        other.cacheable == cacheable &&
        other.deleteCachedObject == deleteCachedObject &&
        other.reason == reason;
  }

  @override
  int get hashCode {
    return code.hashCode ^
        cacheable.hashCode ^
        deleteCachedObject.hashCode ^
        reason.hashCode;
  }
}
