import 'dart:convert';

import 'package:flutter/foundation.dart';

class Shows {
  final List<dynamic> data;
  final int position;
  Shows({
    required this.data,
    required this.position,
  });

  Shows copyWith({
    List<dynamic>? data,
    int? position,
  }) {
    return Shows(
      data: data ?? this.data,
      position: position ?? this.position,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'data': data,
      'position': position,
    };
  }

  factory Shows.fromMap(Map<String, dynamic> map) {
    return Shows(
      data: List<dynamic>.from(map['data']),
      position: map['position']?.toInt(),
    );
  }

  String toJson() => json.encode(toMap());

  factory Shows.fromJson(String source) => Shows.fromMap(json.decode(source));

  @override
  String toString() => 'Shows(data: $data, position: $position)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Shows &&
        listEquals(other.data, data) &&
        other.position == position;
  }

  @override
  int get hashCode => data.hashCode ^ position.hashCode;
}
