import 'dart:convert';

import 'package:flutter/foundation.dart';

import 'data.dart';

class Topquery {
  final List<Data> data;
  final int position;
  Topquery({
    required this.data,
    required this.position,
  });

  Topquery copyWith({
    List<Data>? data,
    int? position,
  }) {
    return Topquery(
      data: data ?? this.data,
      position: position ?? this.position,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'data': data.map((x) => x.toMap()).toList(),
      'position': position,
    };
  }

  factory Topquery.fromMap(Map<String, dynamic> map) {
    return Topquery(
      data: List<Data>.from(map['data']?.map((x) => Data.fromMap(x))),
      position: map['position']?.toInt(),
    );
  }

  String toJson() => json.encode(toMap());

  factory Topquery.fromJson(String source) =>
      Topquery.fromMap(json.decode(source));

  @override
  String toString() => 'Topquery(data: $data, position: $position)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Topquery &&
        listEquals(other.data, data) &&
        other.position == position;
  }

  @override
  int get hashCode => data.hashCode ^ position.hashCode;
}
